 	    	   /******************************************
		   *		  CRITBLK.C		     *
	    	   * Copyright TimeSlice, Inc. 1985, 86, 87. *
	    	   ******************************************/


#include <ts.h>
#include <stdio.h>

/***
* CRITSTART( CLASSNUM )
* this function is called at the beginning of a critical section,
* and makes this process critical for class CLASSNUM until CRITEND( CLASSNUM )
* is called as many times as CRITSTART( CLASSNUM ) has been called while 
* already critical.
***/
void critstart( classnum )
int classnum;
{
  CRCLASS *crcptr;
  int cpuflags;

  crcptr = crit_tab + classnum;

  if( crcptr->crcur != curproc ) {	/*process not yet critical for classnum*/
    cpuflags = cli();
    if( !crcptr->crcur ) {		/*nobody crit or waiting to be crit for that class*/
      crcptr->crcur = curproc;		/*make curproc crit for classnum*/

      if (! classnum && curproc != _mainproc)
	 _mainproc->status |= CRITWAIT;

    } else {
      if( !crcptr->crblkd )		/*nobody waiting for classnum*/
        crcptr->crblkd = curproc;	/*curproc is 1st waiting*/
      else
        crcptr->crrear->crnxt = curproc;/*not first waiting, go to end of list*/
      crcptr->crrear = curproc;		/*update classnum's crrear ptr*/
      curproc->status |= CRITWAIT;	/*wait to be crit for classnum*/
      curproc->crwait = classnum;	/*to know what crit class we are waiting for*/
      guc();
      putf( cpuflags );
      return ;
    }
    putf( cpuflags );
  }
  curproc->crlev++;			/*update crit nesting lev of curproc*/
  crcptr->crlev++;			/*update crit nesting of classnum*/
  return;
}


/***
* CRITEND( CLASSNUM )
* this function is called at the end of a critical section of code.
* it decrements classnum's CRLEV, and if it reaches zero, awakes next process
* on the critical blocked list.	Then it also decrement's the current task's
* crlev and if it reaches -1, it checks for the KILL bit and maybe terminate.
***/
void critend( classnum )
int classnum;
{
  CRCLASS *crcptr;
  int cpuflags;

  crcptr = crit_tab + classnum;

  if( !--crcptr->crlev ) {		/*curproc not crit for classnum*/
    cpuflags = cli() ;

    /*update classnum's crcur, and check if someone waiting for classnum*/
    if( crcptr->crcur = crcptr->crblkd ) {
      PROCESS *blkd;

      blkd = crcptr->crblkd;		/*get hold of 1st task waiting for classnum*/
      blkd->crwait = -1;		/*not waiting for any class*/
      blkd->status &= ~CRITWAIT;	/*reset its CRITWAIT status*/
      blkd->crlev++;			/*update new crcur's crit nesting level*/
      crcptr->crlev++;			/*update crit nesting of classnum*/
      crcptr->crblkd = blkd->crnxt;	/*update list of task blocked for classnum*/
      blkd->crnxt = NULL;		/*reset it*/

      if (! classnum && curproc == _mainproc)
	 _mainproc->status |= CRITWAIT;
    }
    else
    {
      if (! classnum && curproc != _mainproc)
	 _mainproc->status &= ~CRITWAIT;
    }


    putf( cpuflags ) ;
  }
  /*decrement crit lev of task, and check if should die*/
  --curproc->crlev;
  ts_rrip( curproc );

  return;
}

    
