 	    	   /******************************************
		   *		SPAWN.C			     *
	    	   * Copyright TimeSlice, Inc. 1985, 86, 87. *
	    	   ******************************************/


#include <ts.h>
#include <stdio.h>


char *_ts_malloc( int ) ;

/***
* SPAWN( NAME , STKSIZ , FUNC )
* creates a new process named NAME with an allocated stack of STKSIZ words,
* and start executing at FUNC. When FUNC exits, it calls endself().
***/
PROCESS *spawn( name , stksiz, func )
char *name ;
int  stksiz ;
void (*func)();
{
  union {
    int *ptr;
    struct {
      int off,
      	  seg;
    }i;
  }genptr;
  int *d, len, *cpyvargs();
  PROCESS *p;
  void initfpc();

  /*compute total size of area to allocate for name, PROCESS and stack*/
  len = strlen( name ) + 1;
  p = NULL;

  /*try to allocate required memory*/
  if( genptr.ptr = (int*)cpcrit( DOS_CRCLASS, _ts_malloc ,
  	len + stksiz * sizeof(int) + ((_tsfpc && _fpc_support) ? 94 : 0 ))) {	/*set if fpc should be processed*/

    /*copy task name*/
    strcpy( genptr.ptr, name );

    /*initialize some of the PROCESS structure*/
    p = ( PROCESS * ) ( ((char*)genptr.ptr) + len );
    p->name = (char *)genptr.ptr;		/*name of process*/
    p->tunits = 1;				/*numof time units for proc.*/
    p->crnxt = NULL;				/*initialize to default*/
    p->crlev = 0;				/*initialize to default*/
    p->chlev = 0;				/*initialize to default*/
    p->crwait = -1;				/*initialize to default*/
    p->chnxt = NULL;				/*initialize to default*/

    
    /*initialize status to iAPXfpc or not*/
    if( p->status = ( _tsfpc && _fpc_support ) ? SAVEFPC : 0 )
      initfpc( &p->regsfpc );

    /*copy args to func, on top of new stack area*/
    d = cpyvargs( &name, (&func)+1, ((int*)p)+stksiz );

    /*return address of task's 1st func is endself*/
#if defined(ML) || defined(MP)
    *--d = f_seg( endself );
#endif
    *--d = f_off( endself );

    /*simulate slicer's context switching( flags, CS:IP(func), pusha, DS, ES*/
    *--d = FLAGS;				/*put task flags*/
    *--d = f_seg( func );			/*return to func entry pt*/
    *--d = f_off( func );
    d -= 8;					/*simulate pusha*/
    d[3] = d_off(d)+22;				/*initialize BP*/
    *--d = _datseg;				/*assume DS = ES, and */
    *--d = _datseg;				/*PUSH ES, DS*/

    /*set PROCESS's pss/psp to bottom of stack area initialized (i.e.: d)*/
    genptr.i.off = d_off( d );			/*compute "normalized" SS:SP*/
    genptr.i.seg = d_seg( d );
#if defined(LATTICE) && ( defined(ML) ||  defined(MD) )
    /*LATTICE large data model, canonize pointer to base of stack*/
    len = ( (sizeof(PROCESS)+(_tsfpc&&_fpc_support)?94:0) / 0x10) + 1;
    genptr.i.seg += len;
    genptr.i.off -= len * 0x10;    
#endif
    p->pss   = genptr.i.seg;
    p->psp   = genptr.i.off;

    ssleep();
    p->nxt = curproc->nxt;			/*put new proc on run list*/
    curproc->nxt = p;
    swake();
  }
  return( p );
}
